<template>
    <i-form :model="this.data" class='app-form info-form-mode' ref='form'  id='form' style="">
    <input style="display:none;" />
    <row >
            
<i-col v-show="detailsModel.grouppanel2.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel2.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.empodetail.main2_form.details.grouppanel2')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="1" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.empodetailid.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='empodetailid' :itemRules="this.rules.empodetailid" class='' :caption="$t('entities.empodetail.main2_form.details.empodetailid')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.empodetailid.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='empodetailid'
:value="data.empodetailid" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.poname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='poname' :itemRules="this.rules.poname" class='' :caption="$t('entities.empodetail.main2_form.details.poname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.poname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='poname'
:value="data.poname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.wplistname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='wplistname' :itemRules="this.rules.wplistname" class='' :caption="$t('entities.empodetail.main2_form.details.wplistname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.wplistname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='wplistname'
:value="data.wplistname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.itemname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='itemname' :itemRules="this.rules.itemname" class='' :caption="$t('entities.empodetail.main2_form.details.itemname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.itemname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='itemname'
:value="data.itemname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.itemdesc.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='itemdesc' :itemRules="this.rules.itemdesc" class='' :caption="$t('entities.empodetail.main2_form.details.itemdesc')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.itemdesc.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='itemdesc'
:value="data.itemdesc" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.listprice.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='listprice' :itemRules="this.rules.listprice" class='' :caption="$t('entities.empodetail.main2_form.details.listprice')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.listprice.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='listprice'
:value="data.listprice" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.discnt.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='discnt' :itemRules="this.rules.discnt" class='' :caption="$t('entities.empodetail.main2_form.details.discnt')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.discnt.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='discnt'
:value="data.discnt" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.psum.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='psum' :itemRules="this.rules.psum" class='' :caption="$t('entities.empodetail.main2_form.details.psum')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.psum.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='psum'
:value="data.psum" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.price.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='price' :itemRules="this.rules.price" class='' :caption="$t('entities.empodetail.main2_form.details.price')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.price.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='price'
:value="data.price" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.taxrate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='taxrate' :itemRules="this.rules.taxrate" class='' :caption="$t('entities.empodetail.main2_form.details.taxrate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.taxrate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='taxrate'
:value="data.taxrate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.totalprice.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='totalprice' :itemRules="this.rules.totalprice" class='' :caption="$t('entities.empodetail.main2_form.details.totalprice')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.totalprice.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='totalprice'
:value="data.totalprice" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.unitname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='unitname' :itemRules="this.rules.unitname" class='' :caption="$t('entities.empodetail.main2_form.details.unitname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.unitname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='unitname'
:value="data.unitname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.unitrate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='unitrate' :itemRules="this.rules.unitrate" class='' :caption="$t('entities.empodetail.main2_form.details.unitrate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.unitrate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='unitrate'
:value="data.unitrate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.civo.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='civo' :itemRules="this.rules.civo" class='' :caption="$t('entities.empodetail.main2_form.details.civo')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.civo.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='civo'
:value="data.civo" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.podetailstate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='podetailstate' :itemRules="this.rules.podetailstate" class='' :caption="$t('entities.empodetail.main2_form.details.podetailstate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.podetailstate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='podetailstate'
:value="data.podetailstate" tag='EMPODETAILSTATE' codelistType='STATIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.yiju.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='yiju' :itemRules="this.rules.yiju" class='' :caption="$t('entities.empodetail.main2_form.details.yiju')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.yiju.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='yiju'
:value="data.yiju" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.civocopy.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='civocopy' :itemRules="this.rules.civocopy" class='' :caption="$t('entities.empodetail.main2_form.details.civocopy')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.civocopy.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='civocopy'
:value="data.civocopy" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.grouppanel20.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel20.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.empodetail.main2_form.details.grouppanel20')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="1" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.useto.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='useto' :itemRules="this.rules.useto" class='' :caption="$t('entities.empodetail.main2_form.details.useto')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.useto.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='useto'
:value="data.useto" tag='EMUSETO' codelistType='STATIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.equipid.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='equipid' :itemRules="this.rules.equipid" class='' :caption="$t('entities.empodetail.main2_form.details.equipid')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.equipid.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='equipid'
:value="data.equipid" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.objid.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='objid' :itemRules="this.rules.objid" class='' :caption="$t('entities.empodetail.main2_form.details.objid')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.objid.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='objid'
:value="data.objid" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.equips.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='equips' :itemRules="this.rules.equips" class='' :caption="$t('entities.empodetail.main2_form.details.equips')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.equips.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='equips'
:value="data.equips" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.grouppanel25.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel25.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.empodetail.main2_form.details.grouppanel25')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="1" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.rempname.visible" :style="{}"  :lg="{ span: 8, offset: 0 }" :xl="{ span: 8, offset: 0 }">
    <app-form-item name='rempname' :itemRules="this.rules.rempname" class='' :caption="$t('entities.empodetail.main2_form.details.rempname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rempname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='rempname'
:value="data.rempname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.rdate.visible" :style="{}"  :lg="{ span: 8, offset: 0 }" :xl="{ span: 8, offset: 0 }">
    <app-form-item name='rdate' :itemRules="this.rules.rdate" class='' :caption="$t('entities.empodetail.main2_form.details.rdate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rdate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='rdate'
:value="data.rdate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.rsum.visible" :style="{}"  :lg="{ span: 8, offset: 0 }" :xl="{ span: 8, offset: 0 }">
    <app-form-item name='rsum' :itemRules="this.rules.rsum" class='' :caption="$t('entities.empodetail.main2_form.details.rsum')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rsum.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='rsum'
:value="data.rsum" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.runitname.visible" :style="{}"  :lg="{ span: 8, offset: 0 }" :xl="{ span: 8, offset: 0 }">
    <app-form-item name='runitname' :itemRules="this.rules.runitname" class='' :caption="$t('entities.empodetail.main2_form.details.runitname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.runitname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='runitname'
:value="data.runitname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.empname.visible" :style="{}"  :lg="{ span: 8, offset: 0 }" :xl="{ span: 8, offset: 0 }">
    <app-form-item name='empname' :itemRules="this.rules.empname" class='' :caption="$t('entities.empodetail.main2_form.details.empname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.empname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='empname'
:value="data.empname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.rprice.visible" :style="{}"  :lg="{ span: 8, offset: 0 }" :xl="{ span: 8, offset: 0 }">
    <app-form-item name='rprice' :itemRules="this.rules.rprice" class='' :caption="$t('entities.empodetail.main2_form.details.rprice')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rprice.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='rprice'
:value="data.rprice" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.avgtaxfee.visible" :style="{}"  :lg="{ span: 8, offset: 0 }" :xl="{ span: 8, offset: 0 }">
    <app-form-item name='avgtaxfee' :itemRules="this.rules.avgtaxfee" class='' :caption="$t('entities.empodetail.main2_form.details.avgtaxfee')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.avgtaxfee.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='avgtaxfee'
:value="data.avgtaxfee" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.avgtsfee.visible" :style="{}"  :lg="{ span: 8, offset: 0 }" :xl="{ span: 8, offset: 0 }">
    <app-form-item name='avgtsfee' :itemRules="this.rules.avgtsfee" class='' :caption="$t('entities.empodetail.main2_form.details.avgtsfee')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.avgtsfee.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='avgtsfee'
:value="data.avgtsfee" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.shf.visible" :style="{}"  :lg="{ span: 8, offset: 0 }" :xl="{ span: 8, offset: 0 }">
    <app-form-item name='shf' :itemRules="this.rules.shf" class='' :caption="$t('entities.empodetail.main2_form.details.shf')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.shf.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='shf'
:value="data.shf" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.amount.visible" :style="{}"  :lg="{ span: 8, offset: 0 }" :xl="{ span: 8, offset: 0 }">
    <app-form-item name='amount' :itemRules="this.rules.amount" class='' :caption="$t('entities.empodetail.main2_form.details.amount')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.amount.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='amount'
:value="data.amount" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.sumall.visible" :style="{}"  :lg="{ span: 8, offset: 0 }" :xl="{ span: 8, offset: 0 }">
    <app-form-item name='sumall' :itemRules="this.rules.sumall" class='' :caption="$t('entities.empodetail.main2_form.details.sumall')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.sumall.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='sumall'
:value="data.sumall" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.attprice.visible" :style="{}"  :lg="{ span: 8, offset: 0 }" :xl="{ span: 8, offset: 0 }">
    <app-form-item name='attprice' :itemRules="this.rules.attprice" class='' :caption="$t('entities.empodetail.main2_form.details.attprice')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.attprice.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='attprice'
:value="data.attprice" tag='EMATTPRICE' codelistType='STATIC' style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.grouppanel1.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel1.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.empodetail.main2_form.details.grouppanel1')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="2" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.orgid.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='orgid' :itemRules="this.rules.orgid" class='' :caption="$t('entities.empodetail.main2_form.details.orgid')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.orgid.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='orgid'
:value="data.orgid" tag='PFCL_ORG' codelistType='STATIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.description.visible" :style="{}"  :md="{ span: 24, offset: 0 }" :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='description' :itemRules="this.rules.description" class='' :caption="$t('entities.empodetail.main2_form.details.description')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.description.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='description'
:value="data.description" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>


    </row>
</i-form>
</template>

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util } from '@/utils';
import EMPODetailService from '@/service/empodetail/empodetail-service';
import Main2Service from './main2-form-service';

import { FormButtonModel, FormPageModel, FormItemModel, FormDRUIPartModel, FormPartModel, FormGroupPanelModel, FormIFrameModel, FormRowItemModel, FormTabPageModel, FormTabPanelModel, FormUserControlModel } from '@/model/form-detail';
import { debounceTime, distinctUntilChanged } from 'rxjs/operators';


@Component({
    components: {
      
    }
})
export default class Main2Base extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof Main2
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof Main2
     */
    @Prop() public context: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof Main2
     */
    @Prop() public viewparams: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main2
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof Main2
     */
    public getControlType(): string {
        return 'FORM'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof Main2
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {Main2Service}
     * @memberof Main2
     */
    public service: Main2Service = new Main2Service({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {EMPODetailService}
     * @memberof Main2
     */
    public appEntityService: EMPODetailService = new EMPODetailService({ $store: this.$store });
    


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof Main2
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof Main2
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }


    
    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof Main2
     */
    public getDatas(): any[] {
        return [this.data];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof Main2
     */
    public getData(): any {
        return this.data;
    }

    /**
     * 是否默认保存
     *
     * @type {boolean}
     * @memberof Main2
     */
    @Prop({ default: false }) public autosave?: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof Main2
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--submit
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public WFSubmitAction!: string;
    
    /**
     * 部件行为--start
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public WFStartAction!: string;
    
    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public updateAction!: string;
    
    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public removeAction!: string;
    
    /**
     * 部件行为--loaddraft
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public loaddraftAction!: string;
    
    /**
     * 部件行为--load
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public loadAction!: string;
    
    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public searchAction!: string;

    /**
     * 视图标识
     *
     * @type {string}
     * @memberof Main2
     */
    @Prop() public viewtag!: string;

    /**
     * 表单状态
     *
     * @type {Subject<any>}
     * @memberof Main2
     */
    public formState: Subject<any> = new Subject();

    /**
     * 忽略表单项值变化
     *
     * @type {boolean}
     * @memberof Main2
     */
    public ignorefieldvaluechange: boolean = false;

    /**
     * 数据变化
     *
     * @public
     * @type {Subject<any>}
     * @memberof Main2
     */
    public dataChang: Subject<any> = new Subject();

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main2
     */
    public dataChangEvent: Subscription | undefined;

    /**
     * 原始数据
     *
     * @public
     * @type {*}
     * @memberof Main2
     */
    public oldData: any = {};

    /**
     * 表单数据对象
     *
     * @type {*}
     * @memberof Main2
     */
    public data: any = {
        srfupdatedate: null,
        srforikey: null,
        srfkey: null,
        srfmajortext: null,
        srftempmode: null,
        srfuf: null,
        srfdeid: null,
        srfsourcekey: null,
        empodetailid: null,
        poname: null,
        wplistname: null,
        itemname: null,
        itemdesc: null,
        listprice: null,
        discnt: null,
        psum: null,
        price: null,
        taxrate: null,
        totalprice: null,
        unitname: null,
        unitrate: null,
        civo: null,
        podetailstate: null,
        yiju: null,
        civocopy: null,
        useto: null,
        equipid: null,
        objid: null,
        equips: null,
        rempname: null,
        rdate: null,
        rsum: null,
        runitname: null,
        empname: null,
        rprice: null,
        avgtaxfee: null,
        avgtsfee: null,
        shf: null,
        amount: null,
        sumall: null,
        attprice: null,
        orgid: null,
        description: null,
        empodetail:null,
    };

    /**
      * 当前执行的行为逻辑
      *
      * @type {string}
      * @memberof Main2
      */
    public currentAction: string = "";

    /**
      * 关系界面计数器
      *
      * @type {number}
      * @memberof Main2
      */
    public drcounter: number = 0;

    /**
      * 需要等待关系界面保存时，第一次调用save参数的备份
      *
      * @type {number}
      * @memberof Main2
      */
    public drsaveopt: any = {};

    /**
      * 表单保存回调存储对象
      *
      * @type {any}
      * @memberof Main2
      */
    public saveState:any ;

    /**
     * 属性值规则
     *
     * @type {*}
     * @memberof Main2
     */
    public rules: any = {
        srfupdatedate: [
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'blur' },
        ],
        srforikey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfkey: [
            { type: 'string', message: '订单条目号 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '订单条目号 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '订单条目号 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '订单条目号 值不能为空', trigger: 'blur' },
        ],
        srfmajortext: [
            { type: 'string', message: '订单条目名称 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '订单条目名称 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '订单条目名称 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '订单条目名称 值不能为空', trigger: 'blur' },
        ],
        srftempmode: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfuf: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfdeid: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfsourcekey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        empodetailid: [
            { type: 'string', message: '订单条目号 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '订单条目号 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '订单条目号 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '订单条目号 值不能为空', trigger: 'blur' },
        ],
        poname: [
            { type: 'string', message: '订单 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '订单 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '订单 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '订单 值不能为空', trigger: 'blur' },
        ],
        wplistname: [
            { type: 'string', message: '采购申请 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '采购申请 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '采购申请 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '采购申请 值不能为空', trigger: 'blur' },
        ],
        itemname: [
            { type: 'string', message: '物品 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '物品 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '物品 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '物品 值不能为空', trigger: 'blur' },
        ],
        itemdesc: [
            { type: 'string', message: '物品备注 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '物品备注 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '物品备注 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '物品备注 值不能为空', trigger: 'blur' },
        ],
        listprice: [
            { type: 'string', message: '标价 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '标价 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '标价 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '标价 值不能为空', trigger: 'blur' },
        ],
        discnt: [
            { type: 'number', message: '折扣(%) 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '折扣(%) 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '折扣(%) 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '折扣(%) 值不能为空', trigger: 'blur' },
        ],
        psum: [
            { type: 'number', message: '订货数量 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '订货数量 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '订货数量 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '订货数量 值不能为空', trigger: 'blur' },
        ],
        price: [
            { type: 'string', message: '单价 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '单价 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '单价 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '单价 值不能为空', trigger: 'blur' },
        ],
        taxrate: [
            { type: 'number', message: '税率 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '税率 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '税率 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '税率 值不能为空', trigger: 'blur' },
        ],
        totalprice: [
            { type: 'number', message: '总价 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '总价 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '总价 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '总价 值不能为空', trigger: 'blur' },
        ],
        unitname: [
            { type: 'string', message: '订货单位 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '订货单位 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '订货单位 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '订货单位 值不能为空', trigger: 'blur' },
        ],
        unitrate: [
            { type: 'number', message: '单位转换率 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '单位转换率 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '单位转换率 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '单位转换率 值不能为空', trigger: 'blur' },
        ],
        civo: [
            { type: 'string', message: '发票号 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '发票号 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '发票号 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '发票号 值不能为空', trigger: 'blur' },
        ],
        podetailstate: [
            { type: 'string', message: '条目状态 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '条目状态 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '条目状态 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '条目状态 值不能为空', trigger: 'blur' },
        ],
        yiju: [
            { type: 'string', message: '验收凭据 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '验收凭据 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '验收凭据 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '验收凭据 值不能为空', trigger: 'blur' },
        ],
        civocopy: [
            { type: 'string', message: '发票存根 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '发票存根 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '发票存根 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '发票存根 值不能为空', trigger: 'blur' },
        ],
        useto: [
            { type: 'string', message: '用途 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '用途 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '用途 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '用途 值不能为空', trigger: 'blur' },
        ],
        equipid: [
            { type: 'string', message: '设备 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '设备 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '设备 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '设备 值不能为空', trigger: 'blur' },
        ],
        objid: [
            { type: 'string', message: '位置 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '位置 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '位置 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '位置 值不能为空', trigger: 'blur' },
        ],
        equips: [
            { type: 'string', message: '设备集合 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '设备集合 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '设备集合 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '设备集合 值不能为空', trigger: 'blur' },
        ],
        rempname: [
            { type: 'string', message: '收货人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '收货人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '收货人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '收货人 值不能为空', trigger: 'blur' },
        ],
        rdate: [
            { type: 'string', message: '收货日期 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '收货日期 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '收货日期 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '收货日期 值不能为空', trigger: 'blur' },
        ],
        rsum: [
            { type: 'number', message: '收货数量 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '收货数量 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '收货数量 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '收货数量 值不能为空', trigger: 'blur' },
        ],
        runitname: [
            { type: 'string', message: '收货单位 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '收货单位 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '收货单位 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '收货单位 值不能为空', trigger: 'blur' },
        ],
        empname: [
            { type: 'string', message: '记账人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '记账人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '记账人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '记账人 值不能为空', trigger: 'blur' },
        ],
        rprice: [
            { type: 'string', message: '收货单价 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '收货单价 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '收货单价 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '收货单价 值不能为空', trigger: 'blur' },
        ],
        avgtaxfee: [
            { type: 'string', message: '均摊关税 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '均摊关税 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '均摊关税 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '均摊关税 值不能为空', trigger: 'blur' },
        ],
        avgtsfee: [
            { type: 'string', message: '均摊运杂费 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '均摊运杂费 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '均摊运杂费 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '均摊运杂费 值不能为空', trigger: 'blur' },
        ],
        shf: [
            { type: 'string', message: '税费 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '税费 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '税费 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '税费 值不能为空', trigger: 'blur' },
        ],
        amount: [
            { type: 'string', message: '物品金额 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '物品金额 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '物品金额 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '物品金额 值不能为空', trigger: 'blur' },
        ],
        sumall: [
            { type: 'number', message: '含税总金额 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '含税总金额 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '含税总金额 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '含税总金额 值不能为空', trigger: 'blur' },
        ],
        attprice: [
            { type: 'string', message: '价格波动提醒 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '价格波动提醒 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '价格波动提醒 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '价格波动提醒 值不能为空', trigger: 'blur' },
        ],
        orgid: [
            { type: 'string', message: '组织 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '组织 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '组织 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '组织 值不能为空', trigger: 'blur' },
        ],
        description: [
            { type: 'string', message: '描述 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '描述 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '描述 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '描述 值不能为空', trigger: 'blur' },
        ],
    }

    /**
     * 详情模型集合
     *
     * @type {*}
     * @memberof Main2
     */
    public detailsModel: any = {
        grouppanel2: new FormGroupPanelModel({ caption: '基本信息', detailType: 'GROUPPANEL', name: 'grouppanel2', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '', langbase: 'entities.empodetail.main2_form', extractMode: 'ITEM', details: [] } })
, 
        grouppanel20: new FormGroupPanelModel({ caption: '采购申请信息', detailType: 'GROUPPANEL', name: 'grouppanel20', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '', langbase: 'entities.empodetail.main2_form', extractMode: 'ITEM', details: [] } })
, 
        grouppanel25: new FormGroupPanelModel({ caption: '收货信息', detailType: 'GROUPPANEL', name: 'grouppanel25', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '', langbase: 'entities.empodetail.main2_form', extractMode: 'ITEM', details: [] } })
, 
        grouppanel1: new FormGroupPanelModel({ caption: '其它', detailType: 'GROUPPANEL', name: 'grouppanel1', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '', langbase: 'entities.empodetail.main2_form', extractMode: 'ITEM', details: [] } })
, 
        formpage1: new FormPageModel({ caption: '基本信息', detailType: 'FORMPAGE', name: 'formpage1', visible: true, isShowCaption: true, form: this })
, 
        srfupdatedate: new FormItemModel({ caption: '更新时间', detailType: 'FORMITEM', name: 'srfupdatedate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srforikey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srforikey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfkey: new FormItemModel({ caption: '订单条目号', detailType: 'FORMITEM', name: 'srfkey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srfmajortext: new FormItemModel({ caption: '订单条目名称', detailType: 'FORMITEM', name: 'srfmajortext', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srftempmode: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srftempmode', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfuf: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfuf', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfdeid: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfdeid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfsourcekey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfsourcekey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        empodetailid: new FormItemModel({ caption: '订单条目号', detailType: 'FORMITEM', name: 'empodetailid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        poname: new FormItemModel({ caption: '订单', detailType: 'FORMITEM', name: 'poname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 1 })
, 
        wplistname: new FormItemModel({ caption: '采购申请', detailType: 'FORMITEM', name: 'wplistname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 1 })
, 
        itemname: new FormItemModel({ caption: '物品', detailType: 'FORMITEM', name: 'itemname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 1 })
, 
        itemdesc: new FormItemModel({ caption: '物品备注', detailType: 'FORMITEM', name: 'itemdesc', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        listprice: new FormItemModel({ caption: '标价', detailType: 'FORMITEM', name: 'listprice', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        discnt: new FormItemModel({ caption: '折扣(%)', detailType: 'FORMITEM', name: 'discnt', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        psum: new FormItemModel({ caption: '订货数量', detailType: 'FORMITEM', name: 'psum', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        price: new FormItemModel({ caption: '单价', detailType: 'FORMITEM', name: 'price', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        taxrate: new FormItemModel({ caption: '税率', detailType: 'FORMITEM', name: 'taxrate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        totalprice: new FormItemModel({ caption: '总价', detailType: 'FORMITEM', name: 'totalprice', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        unitname: new FormItemModel({ caption: '订货单位', detailType: 'FORMITEM', name: 'unitname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        unitrate: new FormItemModel({ caption: '单位转换率', detailType: 'FORMITEM', name: 'unitrate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        civo: new FormItemModel({ caption: '发票号', detailType: 'FORMITEM', name: 'civo', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        podetailstate: new FormItemModel({ caption: '条目状态', detailType: 'FORMITEM', name: 'podetailstate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        yiju: new FormItemModel({ caption: '验收凭据', detailType: 'FORMITEM', name: 'yiju', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        civocopy: new FormItemModel({ caption: '发票存根', detailType: 'FORMITEM', name: 'civocopy', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        useto: new FormItemModel({ caption: '用途', detailType: 'FORMITEM', name: 'useto', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        equipid: new FormItemModel({ caption: '设备', detailType: 'FORMITEM', name: 'equipid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        objid: new FormItemModel({ caption: '位置', detailType: 'FORMITEM', name: 'objid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        equips: new FormItemModel({ caption: '设备集合', detailType: 'FORMITEM', name: 'equips', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rempname: new FormItemModel({ caption: '收货人', detailType: 'FORMITEM', name: 'rempname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rdate: new FormItemModel({ caption: '收货日期', detailType: 'FORMITEM', name: 'rdate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rsum: new FormItemModel({ caption: '收货数量', detailType: 'FORMITEM', name: 'rsum', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        runitname: new FormItemModel({ caption: '收货单位', detailType: 'FORMITEM', name: 'runitname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        empname: new FormItemModel({ caption: '记账人', detailType: 'FORMITEM', name: 'empname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rprice: new FormItemModel({ caption: '收货单价', detailType: 'FORMITEM', name: 'rprice', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        avgtaxfee: new FormItemModel({ caption: '均摊关税', detailType: 'FORMITEM', name: 'avgtaxfee', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        avgtsfee: new FormItemModel({ caption: '均摊运杂费', detailType: 'FORMITEM', name: 'avgtsfee', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        shf: new FormItemModel({ caption: '税费', detailType: 'FORMITEM', name: 'shf', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        amount: new FormItemModel({ caption: '物品金额', detailType: 'FORMITEM', name: 'amount', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        sumall: new FormItemModel({ caption: '含税总金额', detailType: 'FORMITEM', name: 'sumall', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        attprice: new FormItemModel({ caption: '价格波动提醒', detailType: 'FORMITEM', name: 'attprice', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        orgid: new FormItemModel({ caption: '组织', detailType: 'FORMITEM', name: 'orgid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        description: new FormItemModel({ caption: '描述', detailType: 'FORMITEM', name: 'description', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
    };

    /**
     * 监控表单属性 srfupdatedate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srfupdatedate')
    onSrfupdatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfupdatedate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srforikey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srforikey')
    onSrforikeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srforikey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfkey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srfkey')
    onSrfkeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfkey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfmajortext 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srfmajortext')
    onSrfmajortextChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfmajortext', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srftempmode 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srftempmode')
    onSrftempmodeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srftempmode', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfuf 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srfuf')
    onSrfufChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfuf', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfdeid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srfdeid')
    onSrfdeidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfdeid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfsourcekey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.srfsourcekey')
    onSrfsourcekeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfsourcekey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 empodetailid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.empodetailid')
    onEmpodetailidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'empodetailid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 poname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.poname')
    onPonameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'poname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 wplistname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.wplistname')
    onWplistnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'wplistname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 itemname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.itemname')
    onItemnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'itemname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 itemdesc 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.itemdesc')
    onItemdescChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'itemdesc', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 listprice 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.listprice')
    onListpriceChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'listprice', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 discnt 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.discnt')
    onDiscntChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'discnt', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 psum 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.psum')
    onPsumChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'psum', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 price 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.price')
    onPriceChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'price', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 taxrate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.taxrate')
    onTaxrateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'taxrate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 totalprice 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.totalprice')
    onTotalpriceChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'totalprice', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 unitname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.unitname')
    onUnitnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'unitname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 unitrate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.unitrate')
    onUnitrateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'unitrate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 civo 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.civo')
    onCivoChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'civo', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 podetailstate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.podetailstate')
    onPodetailstateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'podetailstate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 yiju 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.yiju')
    onYijuChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'yiju', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 civocopy 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.civocopy')
    onCivocopyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'civocopy', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 useto 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.useto')
    onUsetoChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'useto', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 equipid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.equipid')
    onEquipidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'equipid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 objid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.objid')
    onObjidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'objid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 equips 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.equips')
    onEquipsChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'equips', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rempname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.rempname')
    onRempnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rempname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rdate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.rdate')
    onRdateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rdate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rsum 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.rsum')
    onRsumChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rsum', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 runitname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.runitname')
    onRunitnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'runitname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 empname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.empname')
    onEmpnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'empname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rprice 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.rprice')
    onRpriceChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rprice', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 avgtaxfee 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.avgtaxfee')
    onAvgtaxfeeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'avgtaxfee', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 avgtsfee 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.avgtsfee')
    onAvgtsfeeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'avgtsfee', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 shf 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.shf')
    onShfChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'shf', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 amount 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.amount')
    onAmountChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'amount', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 sumall 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.sumall')
    onSumallChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'sumall', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 attprice 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.attprice')
    onAttpriceChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'attprice', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 orgid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.orgid')
    onOrgidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'orgid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 description 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main2
     */
    @Watch('data.description')
    onDescriptionChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'description', newVal: newVal, oldVal: oldVal });
    }


    /**
     * 重置表单项值
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main2
     */
    public resetFormData({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
    }

    /**
      * 置空对象
      *
      * @param {any[]} args
      * @memberof EditForm
      */
    public ResetData(_datas:any){
        if(Object.keys(_datas).length >0){
            Object.keys(_datas).forEach((name: string) => {
                if (this.data.hasOwnProperty(name)) {
                    this.data[name] = null;
                }
            });
        }
    }

    /**
     * 表单逻辑
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main2
     */
    public formLogic({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
                
















































    }

    /**
     * 表单值变化
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @returns {void}
     * @memberof Main2
     */
    public formDataChange({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
        if (this.ignorefieldvaluechange) {
            return;
        }
        this.resetFormData({ name: name, newVal: newVal, oldVal: oldVal });
        this.formLogic({ name: name, newVal: newVal, oldVal: oldVal });
        this.dataChang.next(JSON.stringify(this.data));
    }

    /**
     * 表单加载完成
     *
     * @public
     * @param {*} [data={}]
     * @param {string} [action]
     * @memberof Main2
     */
    public onFormLoad(data: any = {},action:string): void {
        if(Object.is(action,"save") || Object.is(action,"autoSave") || Object.is(action,"submit"))
        // 更新context的实体主键
        if(data.empodetail){
            Object.assign(this.context,{empodetail:data.empodetail})
        }
        this.setFormEnableCond(data);
        this.fillForm(data,action);
        this.oldData = {};
        Object.assign(this.oldData, JSON.parse(JSON.stringify(this.data)));
        this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: false });
        this.formLogic({ name: '', newVal: null, oldVal: null });
    }

    /**
     * 值填充
     *
     * @param {*} [_datas={}]
     * @param {string} [action]
     * @memberof Main2
     */
    public fillForm(_datas: any = {},action:string): void {
        this.ignorefieldvaluechange = true;
        Object.keys(_datas).forEach((name: string) => {
            if (this.data.hasOwnProperty(name)) {
                this.data[name] = _datas[name];
            }
        });
        if(Object.is(action,'loadDraft')){
            this.createDefault();
        }
        if(Object.is(action,'load')){
            this.updateDefault();
        }
        this.$nextTick(function () {
            this.ignorefieldvaluechange = false;
        })
    }

    /**
     * 设置表单项是否启用
     *
     * @public
     * @param {*} data
     * @memberof Main2
     */
    public setFormEnableCond(data: any): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setEnableCond(data.srfuf);
        });
    }

    /**
     * 重置草稿表单状态
     *
     * @public
     * @memberof Main2
     */
    public resetDraftFormStates(): void {
        const form: any = this.$refs.form;
        if (form) {
            form.resetFields();
        }
    }

    /**
     * 重置校验结果
     *
     * @memberof Main2
     */
    public resetValidates(): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setError('');
        });
    }

    /**
     * 填充校验结果 （后台）
     *
     * @param {any[]} fieldErrors
     * @memberof Main2
     */
    public fillValidates(fieldErrors: any[]): void {
        fieldErrors.forEach((error: any) => {
            const formItem: FormItemModel = this.detailsModel[error.field];
            if (!formItem) {
                return;
            }
            this.$nextTick(() => {
                formItem.setError(error.message);
            });
        });
    }

    /**
     * 表单校验状态
     *
     * @returns {boolean} 
     * @memberof Main2
     */
    public formValidateStatus(): boolean {
        const form: any = this.$refs.form;
        let validatestate: boolean = true;
        form.validate((valid: boolean) => {
            validatestate = valid ? true : false;
        });
        return validatestate
    }

    /**
     * 获取全部值
     *
     * @returns {*}
     * @memberof Main2
     */
    public getValues(): any {
        return this.data;
    }

    /**
     * 表单项值变更
     *
     * @param {{ name: string, value: any }} $event
     * @returns {void}
     * @memberof Main2
     */
    public onFormItemValueChange($event: { name: string, value: any }): void {
        if (!$event) {
            return;
        }
        if (!$event.name || Object.is($event.name, '') || !this.data.hasOwnProperty($event.name)) {
            return;
        }
        this.data[$event.name] = $event.value;
    }

    /**
     * 设置数据项值
     *
     * @param {string} name
     * @param {*} value
     * @returns {void}
     * @memberof Main2
     */
    public setDataItemValue(name: string, value: any): void {
        if (!name || Object.is(name, '') || !this.data.hasOwnProperty(name)) {
            return;
        }
        if (Object.is(this.data[name], value)) {
            return;
        }
        this.data[name] = value;
    }



    /**
     * 分组界面行为事件
     *
     * @param {*} $event
     * @memberof Main2
     */
    public groupUIActionClick($event: any): void {
        if (!$event) {
            return;
        }
        const item:any = $event.item;
    }

    /**
     * Vue声明周期(处理组件的输入属性)
     *
     * @memberof Main2
     */
    public created(): void {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof Main2
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('autoload', action)) {
                    this.autoLoad(data);
                }
                if (Object.is('load', action)) {
                    this.load(data);
                }
                if (Object.is('loaddraft', action)) {
                    this.loadDraft(data);
                }
                if (Object.is('save', action)) {
                    this.save(data,data.showResultInfo);
                }
                if (Object.is('remove', action)) {
                    this.remove(data);
                }
                if (Object.is('saveandexit', action)) {
                    this.saveAndExit(data);
                }
                if (Object.is('saveandnew', action)) {
                    this.saveAndNew(data);
                }
                if (Object.is('removeandexit', action)) {
                    this.removeAndExit(data);
                }
                if (Object.is('refresh', action)) {
                    this.refresh(data);
                }
            });
        }
        this.dataChang
            .pipe(
                debounceTime(300),
                distinctUntilChanged()
            ).subscribe((data: any) => {
                if (this.autosave) {
                    this.autoSave();
                }
                const state = !Object.is(JSON.stringify(this.oldData), JSON.stringify(this.data)) ? true : false;
                this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: state });
            });
    }

    /**
     * vue 生命周期
     *
     * @memberof Main2
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof Main2
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if (this.dataChangEvent) {
            this.dataChangEvent.unsubscribe();
        }
    }

    /**
     * 拷贝内容
     *
     * @param {*} [arg={}]
     * @memberof @memberof Main2
     */
    public copy(arg: any = {}): void {
        this.loadDraft(arg);
    }

    /**
     *打印
     *@memberof @memberof Main2
     */
    public print(){
        let _this:any = this;
        _this.$print({id:'form',popTitle:'采购订单条目<主信息>'});
    }

    /**
     * 部件刷新
     *
     * @param {any[]} args
     * @memberof Main2
     */
    public refresh(args: any[]): void {
        let arg: any = {};
        Object.assign(arg,args[0]);
        if (this.data.srfkey && !Object.is(this.data.srfkey, '')) {
            Object.assign(arg, { srfkey: this.data.srfkey });
            this.load(arg);
            return;
        }
        if (this.data.srfkeys && !Object.is(this.data.srfkeys, '')) {
            Object.assign(arg, { srfkey: this.data.srfkeys });
            this.load(arg);
            return;
        }
    }

    /**
     * 自动加载
     *
     * @param {*} [arg={}]
     * @returns {void}
     * @memberof Main2
     */
    public autoLoad(arg: any = {}): void {
        if (arg.srfkey && !Object.is(arg.srfkey, '')) {
            Object.assign(arg, { srfkey: arg.srfkey });
            this.load(arg);
            return;
        }
        if (arg.srfkeys && !Object.is(arg.srfkeys, '')) {
            Object.assign(arg, { srfkey: arg.srfkeys });
            this.load(arg);
            return;
        }
        this.loadDraft(arg);
    }

    /**
     * 加载
     *
     * @public
     * @param {*} [opt={}]
     * @memberof Main2
     */
    public load(opt: any = {}): void {
        if(!this.loadAction){
            this.$Notice.error({ title: '错误', desc: 'EMPODETAILEditView9视图表单loadAction参数未配置' });
            return;
        }
        const arg: any = { ...opt };
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        const get: Promise<any> = this.service.get(this.loadAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        get.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                this.onFormLoad(data,'load');
                this.$emit('load', data);
                this.$nextTick(() => {
                    this.formState.next({ type: 'load', data: data });
                });
            }
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 加载草稿
     *
     * @param {*} [opt={}]
     * @memberof Main2
     */
    public loadDraft(opt: any = {}): void {
        if(!this.loaddraftAction){
            this.$Notice.error({ title: '错误', desc: 'EMPODETAILEditView9视图表单loaddraftAction参数未配置' });
            return;
        }
        const arg: any = { ...opt } ;
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        let post: Promise<any> = this.service.loadDraft(this.loaddraftAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            if(data.empodetail){
                Object.assign(this.context,{empodetail:data.empodetail})
            }
            this.resetDraftFormStates();
            this.onFormLoad(data,'loadDraft');
            this.$emit('load', data);
            this.$nextTick(() => {
                this.formState.next({ type: 'load', data: data });
            });
            setTimeout(() => {
                const form: any = this.$refs.form;
                if (form) {
                    form.fields.forEach((field: any) => {
                        field.validateMessage = "";
                        field.validateState = "";
                        field.validateStatus = false;
                    });
                }
            });
        }).catch((response: any) => {
            if (response && response.status  && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 自动保存
     *
     * @param {*} [opt={}]
     * @memberof Main2
     */
    public autoSave(opt: any = {}): void {
        if (!this.formValidateStatus()) {
            return;
        }
        const arg: any = { ...opt };
        const data = this.getValues();
        Object.assign(arg, data);
        const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
        if(!action){
            let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
            this.$Notice.error({ title: '错误', desc: 'EMPODETAILEditView9视图表单'+actionName+'参数未配置' });
            return;
        }
        Object.assign(arg,{viewparams:this.viewparams});
        const post: Promise<any> = this.service.add(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            this.onFormLoad(data,'autoSave');
            this.$emit('save', data);
            this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
            this.$nextTick(() => {
                this.formState.next({ type: 'save', data: data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 保存
     *
     * @param {*} [opt={}]
     * @param {boolean} [showResultInfo] 
     * @param {boolean} [ifStateNext] formState是否下发通知
     * @returns {Promise<any>}
     * @memberof Main2
     */
    public async save(opt: any = {}, showResultInfo?: boolean, ifStateNext: boolean = true): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            showResultInfo = showResultInfo === undefined ? true : false;
            if (!this.formValidateStatus()) {
                this.$Notice.error({ title: '错误', desc: '值规则校验异常' });
                return;
            }
            const arg: any = { ...opt };
            const data = this.getValues();
            Object.assign(arg, data);
            Object.assign(arg, this.context);
            if (ifStateNext) {
                this.drcounter = 0;
                if(this.drcounter !== 0){
                    this.drsaveopt = opt;
                    this.formState.next({ type: 'beforesave', data: arg });//先通知关系界面保存
                    this.saveState = resolve;
                    return;
                }
            }
            const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
            if(!action){
                let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
                this.$Notice.error({ title: '错误', desc: 'EMPODETAILEditView9视图表单'+actionName+'参数未配置' });
                return;
            }
            Object.assign(arg,{viewparams:this.viewparams});
            const post: Promise<any> = Object.is(data.srfuf, '1')?this.service.update(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(action,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
            post.then((response: any) => {
                if (!response.status || response.status !== 200) {
                    if (response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                    }
                    return;
                }

                const data = response.data;
                this.onFormLoad(data,'save');
                this.$emit('save', data);
                this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: data });
                });
                if (showResultInfo) {
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;保存成功！' });
                }
                resolve(response);
            }).catch((response: any) => {
                if (response && response.status  && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
        })
    }

    /**
    * 删除
    *
    * @public
    * @param {*} [opt={}]
    * @memberof EditForm
    */
    public remove(opt:Array<any> = [],showResultInfo?: boolean): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            if(!this.removeAction){
                this.$Notice.error({ title: '错误', desc: 'EMPODETAILEditView9视图表单removeAction参数未配置' });
                return;
            }
            const arg: any = opt[0];
            const _this: any = this;
            Object.assign(arg,{viewparams:this.viewparams});
            this.service.delete(_this.removeAction, JSON.parse(JSON.stringify(this.context)),arg, showResultInfo).then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('remove',data);
                    this.formState.next({ type: 'remove', data: data });
                    this.data.ismodify = false;
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;删除成功！' });
                    resolve(response);
                }
            }).catch((error: any) => {
                const { data: _data } = error;
                this.$Notice.error({ title: _data.title, desc: _data.message });
                reject(error);
            });
        });
    }

    /**
     * 工作流启动
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main2
     */
    public async wfstart(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            const _this: any = this;
            const post: Promise<any> = _this.save({},false);
            post.then((response:any) =>{
                const arg:any = response.data;
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfstart(_this.WFStartAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流启动失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.$Notice.info({ title: '', desc: '工作流启动成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        });
    }

    /**
     * 工作流提交
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main2
     */
    public async wfsubmit(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
        const _this: any = this;
        const arg: any = data[0];
        Object.assign(arg,{viewparams:this.viewparams});
        if (!arg.empodetail || Object.is(arg.empodetail, '')) {
            return;
        }
        const post: Promise<any> = Object.is(arg.srfuf, '1')?this.service.update(this.updateAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(this.createAction,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response:any) =>{
                const arg:any = response.data;
                // 保存完成UI处理
                this.onFormLoad(arg,'save');
                this.$emit('save', arg);
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: arg });
                });
                // 准备提交参数
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfsubmit(_this.WFSubmitAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流提交失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.onFormLoad(arg,'submit');
                    this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                    this.$Notice.info({ title: '', desc: '工作流提交成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        })
    }

    /**
     * 表单项更新
     *
     * @param {string} mode 界面行为名称
     * @param {*} [data={}] 请求数据
     * @param {string[]} updateDetails 更新项
     * @param {boolean} [showloading] 是否显示加载状态
     * @returns {void}
     * @memberof Main2
     */
    public updateFormItems(mode: string, data: any = {}, updateDetails: string[], showloading?: boolean): void {
        if (!mode || (mode && Object.is(mode, ''))) {
            return;
        }
        const arg: any = { ...data };
        Object.assign(arg,this.viewparams);
        const post: Promise<any> = this.service.frontLogic(mode,JSON.parse(JSON.stringify(this.context)),arg, showloading);
        post.then((response: any) => {
            if (!response || response.status !== 200) {
                this.$Notice.error({ title: '错误', desc: '表单项更新失败' });
                return;
            }
            const data = response.data;
            const _data: any = {};
            updateDetails.forEach((name: string) => {
                if (!data.hasOwnProperty(name)) {
                    return;
                }
                Object.assign(_data, { [name]: data[name] });
            });
            this.setFormEnableCond(_data);
            this.fillForm(_data,'updateFormItem');
            this.formLogic({ name: '', newVal: null, oldVal: null });
            this.dataChang.next(JSON.stringify(this.data));
            this.$nextTick(() => {
                this.formState.next({ type: 'updateformitem', ufimode: arg.srfufimode, data: _data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 回车事件
     *
     * @param {*} $event
     * @memberof Main2
     */
    public onEnter($event: any): void {
    }

    /**
     * 保存并退出
     *
     * @param {any[]} args
     * @memberof Main2
     */
    public saveAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndExit";
            _this.save([arg]).then((res) =>{
                if(res){
                    _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 保存并新建
     *
     * @param {any[]} args
     * @memberof Main2
     */
    public saveAndNew(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndNew";
            _this.save([arg]).then((res) =>{
                _this.ResetData(res);
                _this.loadDraft({});
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 删除并退出
     *
     * @param {any[]} args
     * @memberof Main2
     */
    public removeAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.remove([arg]).then((res) =>{
                if(res){
                  _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
    * 关系界面数据保存完成
    *
    * @param {any} $event
    * @memberof Main2
    */
    public drdatasaved($event:any){
        let _this = this;
        this.drcounter--;
        if(this.drcounter > 0){
            return;
        }
        this.save(this.drsaveopt, undefined, false).then((res) =>{
            this.saveState(res);
            this.drsaveopt = {};
            if(Object.is(_this.currentAction, "saveAndNew")){
                _this.ResetData(res);
                _this.loadDraft({});
            }else if(Object.is(_this.currentAction, "saveAndExit")){
                if(res){
                    _this.closeView(res.data);
                }
            }
        });
    }

    /**
     * 新建默认值
     * @memberof Main2
     */
    public createDefault(){                    
    }

    /**
     * 更新默认值
     * @memberof Main2
     */
    public updateDefault(){                    
    }

    
}
</script>

<style lang='less'>
@import './main2-form.less';
</style>